<template>
  <div class="container my-5">
    <h1 class="h2">Shopping cart</h1>
    <p v-if="cart.length < 1">Your shopping cart is empty</p>
    <b-row v-else class="mt-3">
      <b-col class="col-md-9">
        <b-row class="border-top py-2" v-for="item in cart" :key="item.productId">
          <b-col class="col-md-2">
            <img :src="getProduct(item.productId).image" :alt="getProduct(item.productId).title" class="w-100"/>
          </b-col>
          <b-col class="col-md-8">
            <strong class="text-primary">{{ getProduct(item.productId).title }}</strong>
            <b-form-group class="mt-2 mb-0" label-cols="12" label-cols-md="4" label-cols-lg="2" label-size="sm" label-class="text-muted" label="Quantity:" label-for="input-qty">
              <b-form-input id="input-qty" v-model="item.quantity" type="number" min="1" size="sm" class="inputqty"></b-form-input>
            </b-form-group>
            <small class="clickable text-primary" v-on:click="removeProduct(item.productId)"><u>Delete</u></small>

          </b-col>
          <b-col class="col-md-2 text-right">
            $ {{ (getProduct(item.productId).price * item.quantity).toFixed(2) }}
          </b-col>
        </b-row>
      </b-col>
      <b-col class="col-md-3">
        <div class="bg-light p-3">
          <b-row class="text-secondary my-2">
            <b-col>Subtotal</b-col>
            <b-col class="text-right">$ {{ subtotal.toFixed(2) }}</b-col>
          </b-row>
          <b-row class="text-secondary my-2">
            <b-col>Delivery</b-col>
            <b-col class="text-right"><span v-if="delivery > 0">$ {{ delivery.toFixed(2) }}</span><small v-else>FREE</small></b-col>
          </b-row>
          <b-row class="mt-4">
            <b-col><strong>TOTAL</strong></b-col>
            <b-col class="text-right">$ {{ total.toFixed(2) }}</b-col>
          </b-row>
          <b-button v-on:click="proceedToCheckout" variant="primary" class="rounded-0 w-100 mt-3">Proceed to checkout</b-button>
          <div class="mt-3">
            <b-icon icon="arrow-left-right" variant="primary"></b-icon> <small class="text-muted">100% satisfied or refunded</small>
            <br><b-icon icon="truck" variant="primary"></b-icon> <small class="text-muted">FREE delivery from $60</small>
          </div>
        </div>
      </b-col>
    </b-row>
  </div>
</template>

<script>
import { mapState } from 'vuex'
import { mapFields } from 'vuex-map-fields'

export default {
  name: 'Panier',
  computed: {
    ...mapState([
      'products',
      'user'
    ]),
    ...mapFields([
      'cart'
    ]),
    subtotal () {
      let price = 0
      this.cart.forEach(item => {
        const product = this.products.find(p => p.id === item.productId)
        price = price + (product.price * item.quantity)
      })
      return price
    },
    delivery () {
      let delivery = 9.95
      if (this.subtotal > 60) delivery = 0
      return delivery
    },
    total () {
      return this.subtotal + this.delivery
    }
  },
  methods: {
    getProduct (id) {
      return this.products.find(p => p.id === id)
    },
    removeProduct (id) {
      const newCart = this.cart.filter(item => item.productId !== id)
      this.cart = newCart
    },
    proceedToCheckout () {
      if (this.user.id) {
        this.$router.push({ name: 'Order' })
      } else {
        this.$router.push({ name: 'Connexion', query: { redirect: '/Panier' } })
      }
    }
  }
}
</script>

<style scoped>
.inputqty {
  width: 80px;
}
</style>
